// config: norepeat

function GetObject( objectpicker )
{
	objectpicker.min = objectpicker.max = 1;

	var done = true;

	while ( 1 )
	{
		if ( !objectpicker.waitForEvent() )
			return false;

		if ( objectpicker.event == 'finished' && done )
		{

			if ( objectpicker.objects.numBReps )
			{
				done = false;
				//moi.geometryDatabase.isolate();
				objectpicker.resetAllow();
				//objectpicker.allowBReps();
				objectpicker.allowFaces();
				//objectpicker.allowEdgeCurves();

				objectpicker.min = 1;
				objectpicker.max = 0;

				moi.ui.beginUIUpdate();
				moi.ui.hideUI( 'CancelContainer' );
				moi.ui.showUI( 'DoneCancelContainer' );
				moi.ui.endUIUpdate();
			}
			else
				break;
		}
		else if ( objectpicker.event == 'done' || !done )
		{
			if ( objectpicker.done() )
			
				break;

			return false;
		}
		
	}

	objectpicker.objects.lockSelection();

	return true;
}

function drawBbox(bbox)
{
var bboxx=moi.VectorMath.createPoint(bbox.min.x+bbox.xLength,bbox.min.y,bbox.min.z);
var bboxy=moi.VectorMath.createPoint(bbox.min.x,bbox.min.y+bbox.yLength,bbox.min.z);
var factory1 = moi.command.createFactory( 'box3pts' );
	factory1.setInput( 0, bbox.min );
	factory1.setInput( 1, bboxx );
	factory1.setInput( 2, bboxy );
	factory1.setInput( 5, bbox.zLength );
	factory1.commit();
}


function SelectObjectsByType()
{
	var preselection = moi.geometryDatabase.getSelectedObjects();
//	moi.ui.commandUI['out'].value = 5;
	var objectpicker = moi.ui.createObjectPicker();
	objectpicker.resetAllow();
	objectpicker.allowBReps();
	//objectpicker.allowFaces();

	if ( !GetObject( objectpicker ) )
	{
		//preselection.setProperty( 'selected', true );
		return;
	}
//	moi.ui.commandUI['out'].value = "";
	var picked = objectpicker.objects;
	
	var picker = moi.ui.createOrientationPicker();
	picker.noDefaultFrame = true;
	
	moi.ui.beginUIUpdate();
	moi.ui.hideUI( 'SelectPrompt1' );
	moi.ui.showUI( 'SelectPrompt2' );
	moi.ui.endUIUpdate();
	
	while ( true )
	{
		if ( !picker.waitForEvent() ) return;
		if ( picker.event === 'finished' || picker.event === 'done' )
		{
			frame = moi.VectorMath.createFrame(picker.frame.origin, picker.frame.xaxis, picker.frame.yaxis );
			break;
		}
	}
	
	
picker.reset();
picked.setProperty( 'selected', false );


var pa1 = frame.evaluate(0,0,0);
var pa2 = frame.evaluate(0,0,1);

	
	moi.ui.beginUIUpdate();
	moi.ui.showUI( 'diameteroptions' );
	moi.ui.hideUI( 'SelectPrompt2' );
	moi.ui.showUI( 'SelectPrompt3' );
	moi.ui.endUIUpdate();

if(moi.ui.commandUI.deltype.value){
//delete the picked faces	
	var factory = moi.command.createFactory( 'delete' );
	factory.setInput( 0, picked );
	factory.commit();

//get the edges of the baseobject
	var presel = moi.geometryDatabase.getObjects();
	presel=presel.item(presel.length-1).getNakedEdges();

//delete the edges
	factory.reset();
	factory = moi.command.createFactory( 'delete' );
	factory.setInput( 0, presel );
	factory.commit();
}	
var sput=moi.VectorMath.createPoint(0, 0, 0);

	factory.reset();
	var factory = moi.command.createFactory( 'copy' );
	factory.setInput( 0, picked);
	factory.setInput( 1, sput);
	factory.setInput( 2, sput);
//	factory.setInput( 3, true);
	var copyobj=factory.calculate();

var holeobj = moi.geometryDatabase.getObjects();
var	hoobj = holeobj.getSolids();


	factory.reset();
	var factory = moi.command.createFactory( 'planarsrf' );
	factory.setInput( 0, copyobj );
	var copyobj=factory.calculate();
	var tool = copyobj;

	
	var bbox = copyobj.item(0).getBoundingBox(0);
//	drawBbox(bbox);
	moi.ui.beginUIUpdate();
	moi.ui.hideUI( 'deltype' );
	moi.ui.endUIUpdate();
	moi.ui.commandUI['oldD'].numericValue = bbox.xLength;
	moi.ui.commandUI['newD'].numericValue = bbox.xLength;
	var inn=moi.ui.commandUI['newD'].numericValue *1.0;
	var scale =inn/bbox.xLength;
	moi.ui.commandUI['scale'].numericValue = scale;
	

	factory.reset();
	factory = moi.command.createFactory( 'scale2d' );
	factory.setInput( 0, tool);
	factory.setInput( 1, frame);
	factory.setInput( 2, scale);
	factory.setInput( 3, frame.origin);
	factory.setInput( 4, sput);
	factory.setInput( 5, 0);

	moi.ui.bindUIToInput( 'scale', 'value', factory.getInput(2) );
		
var commandDialog = moi.ui.commandDialog;
while ( 1 )
	{
		
		if ( !commandDialog.waitForEvent() )
			return;
			
		if ( commandDialog.event == 'done' )
			break;
	}
var tool=factory.calculate();

	moi.ui.beginUIUpdate();
	moi.ui.hideUI( 'diameteroptions' );
	moi.ui.showUI( 'zscale' );
	moi.ui.hideUI( 'SelectPrompt3' );
	moi.ui.showUI( 'SelectPrompt4' );
	moi.ui.endUIUpdate();

	scale=1;
	moi.ui.commandUI['scalez'].numericValue = scale;

	factory.reset();
	factory = moi.command.createFactory( 'scale1d' );
	factory.setInput( 0, tool);
	factory.setInput( 1, pa1);
	factory.setInput( 2, scale);
	factory.setInput( 3, pa2);
	//factory.setInput( 4, frame.zaxis);

	moi.ui.bindUIToInput( 'scalez', 'value', factory.getInput(2) );
	
var commandDialog = moi.ui.commandDialog;
while ( 1 )
	{
		if ( !commandDialog.waitForEvent() )
			return;
			
		if ( commandDialog.event == 'done' )
			break;
	}
tool=factory.calculate();	
//moi.ui.alert("Delete?");
if(!moi.ui.commandUI.subtype.value){		
	factory.reset();
	var factory = moi.command.createFactory( 'booleandifference' );
	factory.setInput( 0, hoobj );
	factory.setInput( 1, tool );
	factory.setInput( 2, false);
	factory.commit();
}else{
moi.geometryDatabase.addObjects(tool);
tool.setProperty('name','HoleTool');

moi.geometryDatabase.deselectAll();
tool.setProperty('selected',1);
}

	
//moi.geometryDatabase.isolate();

}

SelectObjectsByType();
